
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;|Missle Command
;|By: Bryan Thomas
;|version 1.0
;|
;|comments or Question: brt80@hotmail.com
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


#include asm86.h
#include ti86asm.inc

        .org _asm_exec_ram

;-----------------Shell title-----------------------------
        nop
        jp Main
        .dw $0000
        .dw Shell_Title
;---------------------------------------------------------

Main:
        call BUSY_OFF      ;turn run indicator off

        ld a,($C008)       ;find the initial contrast
        push af
        call _clrScrn      ;clear the screen an d set graph mem = to zeros
        call TitleScrn     ;Show the title picture
        call OptionScrn    ;go to the option screen
        pop af             ;pop the original  contrast
        ld ($C008),a       ;
        out (2),a          ;send the contrast value
        ret                ;return to Shell,Ti-OS
;----------------------------------------------------------
;-------------------------Game Loop------------------------
GameBegin:
         call _clrLCD
         call DrawLandScape



KeyTest:
        ld   a,0ffh                  ;Reset keyport
        out  (1),a                   ;Clear Port
        ld   a,0feh                  ;Load desired port
        out  (1),a                   ;Clear Keys
        in   a,(1)                   ;Input Key
        cp   251                     ;If key is right
        push af
        call z,MoveCursorRight               ;Goto Right
        pop  af
        cp   247
        push af
        call z,MoveCursorUp
        pop  af
        cp   253                     ;If key is left
        push af
        call z,MoveCursorLeft                ;Goto Left
        pop  af
        cp   254
        call z,MoveCursorDown
        ld   a,0ffh                  ;Reset keyport
        out  (1),a                   ;Clear Port
        ld   a,0bfh                  ;Load desired port
        out  (1),a                   ;Clear Keys
        in   a,(1)                   ;Input Key
        cp   223                     ;Is it 2nd
        jp   z,OptionScrn                  ;Fire if so
        cp   191                     ;Is it Exit [Note - would result in Key Delete on 83]
        jp   z,OptionScrn                                           
        cp   127                     ;Is it more
        call z,ContrastScrn            ; Jump to pause                               
        call  z,DrawLandScape
        ld   a,0ffh                  ;Reset keyport
        out  (1),a                   ;Clear Port
        ld   a,0dfh                  ;Load desired port
        out  (1),a                   ;Clear Keys
        in   a,(1)                   ;Input Key
        cp   127                     ;Is it Alpha
        jp   z,OptionScrn                  ;Fire if so
        
                                 ;Goto NoKeyLoop if no key

NoKeyLoop:
        call MoveMissles                 ;Move the Target
        ;call CheckFire                  ;Checks the FireBall
        jr KeyTest                     ;Goto GameLoop
        
;------------------------------Move The missles-----------------------------
MoveMissles:

        ld a,(MissleC)
        cp 0
        jp z,MoveMissle2
        dec a
        ld (MissleC),a
        ret 
MoveMissle2:
        ld a,254
        ld (MissleC),a
        ld a,(MissleC2)
        cp 0
        jp z,MoveMissle3
        dec a
        ld (MissleC2),a
        ret 
        

MoveMissle3:
        ld a,254
        ld (MissleC),a
        ld a,10
        ld (MissleC2),a
        ld a,(MissleY)
        inc a
        cp 53
        call z,Reset
        ld (MissleY),a
        ld e,a
        ld a,23
        ld hl,Missle
        call PutSprite
        ld a,(MissleY)
        ld e,a
        ld a,43
        ld hl,Missle
        call PutSprite
        ld a,(MissleY)
        ld e,a
        ld a,63
        ld hl,Missle
        call PutSprite
        ld a,(MissleY)
        ld e,a
        ld a,83
        ld hl,Missle
        call PutSprite
        ld a,(MissleY)
        ld e,a
        ld a,103
        ld hl,Missle
        call PutSprite
        ret

Reset:
     ld a,254
     ret

;-------------------------Move Cursor Left----------------------------------
MoveCursorLeft:
         ld a,(AimX)
         cp 1
         ret z
         call PutCross
         dec a
         ld (AimX),a
         call PutCross
         ret

;-------------------------Move Cursor Right----------------------------------
MoveCursorRight:
         ld a,(AimX)
         cp 120
         ret z
         call PutCross
         inc a
         ld (AimX),a
         call PutCross
         ret

;-------------------------Move Cursor Down----------------------------------
MoveCursorDown:
         ld a,(AimY)
         cp 40
         ret z
         call PutCross
         inc a
         ld (AimY),a
         call PutCross
         ret

;-------------------------Move Cursor up----------------------------------
MoveCursorUp:
         ld a,(AimY)
         cp 1
         ret z
         call PutCross
         dec a
         ld (AimY),a
         call PutCross
         ret
;-------------------------Draw the Cross Sprite---------------------------
PutCross:
        push af
        ld a,(AimY)
        ld e,a
        ld a,(AimX)
        ld hl,CrossHair
        call PutSprite
        pop af
        ret
;-------------------------Draw The Land Scape-----------------------------
DrawLandScape:

         call _clrLCD
         ld b,0                          ;Setting Coords
         ld c,7                         ;Set Coords
         ld d,128                        ;Set Coords
         ld e,7                         ;Set Coords
         ld h,1                          ;H = 1 for Shading [2 = Unshade, 3 = XOR]
         call  _ILine                    ;Draw the Line!
         set 3,(iy+5)                    ;Set text to inverse
         ld hl,58*256+20                 ;Set Coordinates
         ld (_penCol),hl                 ;Put them into HL
         ld hl,BlankStr                  ;Load Title String 
         call _vputs                      ;Display it!

         ld hl,58*256+85                ;Set Coordinates
         ld (_penCol),hl                 ;Put them into HL
         ld hl,BlankStr                  ;Load Title String 
         call _vputs                     ;Display it!

         ld hl,58*256+30                  ;Set Coordinates
         ld (_penCol),hl                 ;Put them into HL
         ld hl,GameTitle                  ;Load Title String 
         call _vputs                     ;Display it!

         ld hl,58*256+92                 ;Set Coordinates
         ld (_penCol),hl                 ;Put them into HL
         ld hl,GameScore                  ;Load Title String 
         call _vputs                     ;Display it!

         ld hl,58*256+0                ;Set Coordinates
         ld (_penCol),hl                 ;Put them into HL
         ld hl,GameLives                  ;Load Title String 
         call _vputs                     ;Display it!

         ld a,0
         ld e,48
         ld hl,CannonL
         call PutSprite
         ld a,119
         ld e,48
         ld hl,CannonR
         call PutSprite

         ld a,20
         ld e,48
         ld hl,Building
         call PutSprite
         ld a,40
         ld e,48
         ld hl,Building
         call PutSprite
         ld a,60
         ld e,48
         ld hl,Building
         call PutSprite
         ld a,80
         ld e,48
         ld hl,Building
         call PutSprite
         ld a,100
         ld e,48
         ld hl,Building
         call PutSprite
         
         call PutCross
         ret
;------------------------Key Screen-----------------------
KeyScreen:
       call Template       ;Draw the template
       xor a
       ld (_curCol),a
       inc a
       ld (_curRow),a
       ld hl,KeyText
       call _puts
KeyKeyloop:
       call GET_KEY
       cp K_NOKEY
       jr z,KeyKeyloop
       jp OptionScrn
;----------------------------------------------------------
;------------------------Contrast Screen-----------------
ContrastScrn:

        call _clrLCD
        call Template      ;Draw the Template
        xor a              ;a=0
        ld (_curCol),a     ;col=0
        inc a              ;a=1 
        ld (_curRow),a     ;row=1
        ld hl,ContrastText   ;load the text
        call _puts         ;Display the Text
        
ContrastKeyLoop:
        call GET_KEY       ;wait for a key press
        cp K_UP
        call z,IncreaseContrast
        cp K_DOWN
        call z,DecreaseContrast
        cp K_XVAR
        ret z
        jr ContrastKeyLoop

IncreaseContrast:
        ld a,($C008)
        cp 31
        ret z
        inc a
        ld ($C008),a
        out (2),a
        ret

DecreaseContrast:
        ld a,($C008)
        cp 0 
        ret z
        dec a
        ld ($C008),a
        out (2),a
        ret

;---------------------------------------------------------------------


;------------------------Option Screen-------------------
OptionScrn:
        call Template      ;Draw the Template
        xor a              ;a=0
        ld (_curCol),a     ;col=0
        inc a              ;a=1 
        ld (_curRow),a     ;row=1
        ld hl,OptionText   ;load the text
        call _puts         ;Display the Text
OptionKeyLoop:
        call GET_KEY       ;wait for a key press
        cp K_F1            ;
        jp z,GameBegin      ;
        cp K_F2            ;[F2] to show screens
        jp z,KeyScreen    ;
        cp K_F3            ;[F3] for contrast adjustment
        call z,ContrastScrn;
        jp z,OptionScrn
        cp K_F4            ;exit the entire game
        ret z              ;
        jr OptionKeyLoop   ;
;--------------------------------------------------------

;------------------------Template------------------------
Template:
        call _clrLCD       ;clear the display
        set 3,(iy+5)       ;set inverse text mode
        ld hl,0            ;make a=0
        ld (_curRow),hl    ;set row and column=0
        ld hl,TemplateTitle  ;load "Missle Command         v1.0"
        call _puts
        res 3,(iy+5)
        ld hl,58*256+8     ;load coordinate into hl
        ld (_penCol),hl    ;the coordinate into pencol and penrow
        ld hl,TemplateComments
        call _vputs
        ret

;------------------------Title Screen--------------------------
TitleScrn:
        ld a,0
        ld hl, Title            ;load the Title picture
        ld de, $FC90            ;point to video mem(row 10) 
        ld bc, $0170            ;load the screen offset
        ldir                    ;load...increment...repeat
        ld hl,50*256+30
        ld (_penCol),hl
        ld hl,Author
        call _vputs
TitleKeyLoop:
        call GET_KEY
        cp 0                                ;wait for a keypress
        jr z,TitleKeyLoop
        ret                     ;return

Title:        
        .db     $00,$00,$00,$00,$00,$00,$07,$01,$CF,$FF,$8F,$FF,$0F,$FF,$18,$00
        .db     $1F,$FF,$80,$00,$00,$00,$04,$82,$48,$00,$90,$00,$90,$00,$94,$00
        .db     $10,$00,$80,$00,$00,$00,$04,$44,$4F,$DF,$97,$FF,$97,$FF,$94,$00
        .db     $17,$FF,$00,$00,$00,$00,$05,$29,$40,$50,$14,$00,$14,$00,$14,$00
        .db     $14,$00,$00,$00,$00,$00,$05,$93,$40,$50,$14,$00,$14,$00,$14,$00
        .db     $14,$00,$00,$00,$00,$00,$05,$45,$40,$50,$17,$FF,$17,$FF,$14,$00
        .db     $17,$F0,$00,$00,$00,$00,$05,$29,$40,$50,$10,$00,$90,$00,$94,$00
        .db     $10,$08,$00,$00,$00,$00,$05,$11,$40,$50,$0F,$FE,$8F,$FE,$94,$00
        .db     $17,$F8,$00,$00,$00,$00,$05,$01,$40,$50,$00,$02,$80,$02,$94,$00
        .db     $14,$00,$00,$00,$00,$00,$05,$01,$40,$50,$00,$02,$80,$02,$94,$00
        .db     $14,$00,$00,$00,$00,$00,$05,$01,$4F,$DF,$9F,$FE,$9F,$FE,$97,$FF
        .db     $17,$FF,$00,$00,$00,$00,$05,$01,$48,$00,$90,$00,$90,$00,$90,$00
        .db     $90,$00,$80,$00,$00,$00,$06,$00,$CF,$FF,$8F,$FF,$0F,$FF,$1F,$FF
        .db     $9F,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
        .db     $00,$00,$00,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .db     $FF,$FF,$80,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00
        .db     $00,$00,$80,$00,$00,$00,$04,$3F,$87,$E0,$C1,$83,$06,$0F,$C1,$88
        .db     $FC,$18,$80,$00,$00,$00,$04,$40,$08,$10,$A2,$82,$8A,$10,$21,$48
        .db     $82,$18,$80,$00,$00,$00,$04,$40,$08,$10,$94,$82,$52,$1F,$E1,$28
        .db     $82,$00,$80,$00,$00,$00,$04,$3F,$87,$E0,$88,$82,$22,$10,$21,$18
        .db     $FC,$18,$80,$00,$00,$00,$04,$00,$00,$00,$00,$00,$00,$00,$00,$00
        .db     $00,$00,$80,$00,$00,$00,$07,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        .db     $FF,$FF,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;-----------------------------------------------------------------------------------

;----------------------
;|Sprite Routine [XOR]
;----------------------
;------------------------------------------------------
;|This Routine was converted by AVD from Movax's 83
;|Special thanks to ScaBBy for making it XOR Routine!
;------------------------------------------------------

;hl = image
;a = x coord
;e = y coord

PutSprite:
       push    hl              ; Save sprite address

;--------------------Calculate the address in graphbuf--------------

        ld      hl,0            ; Do y*12
        ld      d,0
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,$FC00
        add     hl,de           ; Add address to graphbuf

        ld      b,00000111b     ; Get the remainder of x/8
        and     b
        cp	0               ; Is this sprite aligned to 8*n,y?
        jp      z,ALIGN


;-------Non aligned sprite blit starts here-----------------

        pop     ix              ; ix->sprite
        ld      d,a             ; d=how many bits to shift each line

        ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

        ld      c,0             ; Shift loop
        push    de
SHLOP:  srl     b
        rr      c
        dec     d
        jp      nz,SHLOP
        pop     de

        ld      a,b             ; Write line to graphbuf
        xor     (hl)
        ld      (hl),a
        inc     hl
        ld      a,c
        xor     (hl)
        ld      (hl),a

        ld      bc,15           ; Calculate next line address
        add     hl,bc
        inc     ix              ; Inc spritepointer

        dec     e
        jp      nz,LILOP        ; Next line

        jp      DONE1


;-------Aligned sprite blit starts here---------------

ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
        ld      b,8
ALOP1:  ld      a,(de)
        xor      (hl)            ; xor=erase/blit
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,16
        add     hl,bc
        pop     bc
        djnz    ALOP1

DONE1:
        ret
;---------------SPRITE ----------------------------------------------------
;-----------------------------Sprite Images--------------------------------
CannonL:
        .db %00000011
        .db %00000110
        .db %00011100
        .db %01111110
        .db %10000001
        .db %11111111
        .db %10000001
        .db %10011001

CannonR:
        .db %11000000
        .db %01100000
        .db %00111000
        .db %01111110
        .db %10000001
        .db %11111111
        .db %10000001
        .db %10011001


Building:
        .db %11111111
        .db %10000001
        .db %10100101
        .db %10000001
        .db %10100101
        .db %10000001
        .db %10011001
        .db %10011001

CrossHair:
        .db %00010000
        .db %00111000
        .db %01010100
        .db %11111110
        .db %01010100
        .db %00111000
        .db %00010000
        .db %00000000
        
Missle:
        .db %01000000
        .db %11100000
        .db %01000000
        .db %11100000
        .db %01000000
        .db %00000000
        .db %00000000
        .db %00000000
        
        
      


Shell_Title:
 .db "MISSLE COMMAND by BRT 1998",0
;------------------------Strings-------------------------------------
Author:        .db "By BRYAN THOMAS v1.0",0
TemplateTitle: .db "Missle Command   v1.0",0
TemplateComments:  .db "Comments?  <brt80@hotmail.com>",0

KeyText:
        .db "   Key Assignments   "
        .db " [Arrows] Aim Missles"
        .db " [2nd]     Fire Left "
        .db " [Alpha]  Fire Right "
        .db " [More]     Pause    "
        .db " [EXIT]      EXIT    ",0

ContrastText:
        .db "                     "
        .db " Contrast Adjustment "
        .db "   [ up ]  increase  "
        .db "   [down]  decrease  "
        .db "   [xVar]   return   ",0

OptionText:
        .db "                     "
        .db "   [F1] Start Game   "
        .db "   [F2]    Keys      "
        .db "   [F3]  Contrast    "
        .db "   [F4]    EXIT      ",0
GameTitle:        .db "MISSLE COMMAND",0
GameScore:        .db "SCORE: 256 ",0
GameLives:        .db " LIVES: 5",0
BlankStr:         .db "                 ",0
;---------------------------------------------------------------------
;----------------------------Variables--------------------------------
AimX: .db 20       ;Aiming mech x position
AimY: .db 20       ;Aiming mech y position
MissleY: .db 254     ;Missle y coordinate
MissleC: .db 0
MissleC2: .db 0
;---------------------------------------------------------------------
.end
